Bug 730686 - Huge performance regression in NFS client [rhel-5.7.z]
Summary: Huge performance regression in NFS client [rhel-5.7.z]
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.7
Hardware: x86_64
OS: Linux
urgent
high
Target Milestone: rc
: ---
Assignee: Phillip Lougher
QA Contact: Jian Li
URL:
Whiteboard:
Depends On: 728508
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-08-15 11:29 UTC by RHEL Product and Program Management
Modified: 2018-11-28 20:42 UTC (History)
31 users (show)

Fixed In Version: kernel-2.6.18-274.4.1.el5
Doc Type: Bug Fix
Doc Text:
A previously introduced patch forced the ->flush and ->fsync operations to wait on all WRITE and COMMIT remote procedure calls (RPC) to complete to ensure that those RPCs were completed before returning from fsync() or close(). As a consequence, all WRITEs issued by nfs_flush_list were serialized and caused a performance regression on NFS clients. This update changes nfs_flush_one and nfs_flush_multi to not wait for WRITEs issued when the FLUSH_SYNC parameter is set, resolving performance issues on NFS clients.
Clone Of:
Environment:
Last Closed: 2011-10-20 17:31:01 UTC


Attachments (Terms of Use)
nfs performance test output (13.17 KB, text/plain)
2011-10-08 05:06 UTC, Jian Li
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:1386 normal SHIPPED_LIVE Important: kernel security, bug fix, and enhancement update 2011-10-20 17:28:15 UTC

Description RHEL Product and Program Management 2011-08-15 11:29:09 UTC
This bug has been copied from bug #728508 and has been proposed
to be backported to 5.7 z-stream (EUS).

Comment 4 Phillip Lougher 2011-09-14 09:40:52 UTC
in kernel-2.6.18-274.4.1.el5

linux-2.6-fs-nfs-have-nfs_flush_list-issue-flush_sync-writes-in-parallel.patch

Comment 9 Jian Li 2011-10-08 05:04:48 UTC
This bug is tested in three kernel package, and nfs server use rhel6. Test result is attached, brief info is listed below:

kernel-2.6.18-238
"Writer report"
        "128"
"65536"   41923 

kernel-2.6.18-274.5.1
"Writer report"
        "128"
"65536"   41594 

kernel-2.6.18-274
"Writer report"
        "128"
"65536"   30490 

There are many element that effect the result, and the result is steady.

Comment 10 Jian Li 2011-10-08 05:06:12 UTC
Created attachment 526995 [details]
nfs performance test output

Comment 12 errata-xmlrpc 2011-10-20 17:31:01 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2011-1386.html

Comment 13 Martin Prpič 2011-10-27 09:19:40 UTC
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
A previously introduced patch forced the ->flush and ->fsync operations to wait on all WRITE and COMMIT remote procedure calls (RPC) to complete to ensure that those RPCs were completed before returning from fsync() or close(). As a consequence, all WRITEs issued by nfs_flush_list were serialized and caused a performance regression on NFS clients. This update changes nfs_flush_one and nfs_flush_multi to not wait for WRITEs issued when the FLUSH_SYNC parameter is set, resolving performance issues on NFS clients.


Note You need to log in before you can comment on or make changes to this bug.